#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string.h>
#include <time.h>
#include <cstdlib>
#include <windows.h>
#define INF 9999999999999999
using namespace std;
typedef long long lld;

struct GRPH
{
    lld vert;
    lld val;

    void SetValues(lld a, lld b)
    {
        vert = a;
        val = b;
    }
};

struct VRTX
{
    lld vert1, vert2;
    lld val, ind;

    void SetValues(lld a, lld b, lld c, lld d)
    {
        vert1 = a;
        vert2 = b;
        val = c;
        ind = d;
    }
    bool operator<(const VRTX& other)const
    {
        return (ind < other.ind);
    }
};

struct UFStructure
{
    lld father[302];
    vector<VRTX> vertex;

    void Initialize()
    {
        memset(father, 0, sizeof(father));
        vertex.clear();
    }

    lld Find(lld vert)
    {
        if (father[vert] == 0)
        {
            return vert;
        }

        lld root = Find(father[vert]);
        father[vert] = root;

        return root;
    }

    bool Union(lld vert1, lld vert2)
    {
        lld root1, root2;

        root1 = Find(vert1);
        root2 = Find(vert2);

        if (root1 == root2) return false;

        father[root1] = root2;
        return true;
    }

    void AddVertex(lld v1, lld v2, lld val, lld ind)
    {
        VRTX helper;
        //cout<<"hei"<<endl;
        helper.SetValues(v1, v2, val, ind);
        vertex.push_back(helper);

       // cout<<"ura"<<endl;
    }
    void AddVertex(VRTX cool)
    {
        Union(cool.vert1, cool.vert2);

        vertex.push_back(cool);
    }

    void SetAllVerts(vector<VRTX> cool)
    {
        vertex = cool;
    }

    void GetReady()
    {
        sort(vertex.begin(), vertex.end());
    }


    vector<lld> GetAnswer()
    {
        vector<lld> ret;
        lld i;

        ret.clear();

        for (i=0;i<vertex.size();i++)
        {
            if (Union(vertex[i].vert1, vertex[i].vert2))
            {
                ret.push_back(vertex[i].ind);
            }
        }
        return ret;
    }

    bool DiffComp(lld vert1, lld vert2)
    {
        return (Find(vert1) != Find(vert2));
    }
};

void MakeEaq(UFStructure *source, UFStructure *target)
{
    for (lld i=0;i<302;i++)
    {
        (*target).father[i] = (*source).father[i];
    }
    (*target).vertex = (*source).vertex;
}

struct Cool
{
    lld vert, dist;
};

struct RangeMinimumQuery
{
    lld nums[702],n;

    lld chooselen[702];
    lld powah[12];

    lld RMQ[702][12];

    lld MN(lld a,lld b)
    {
        if (a<b) return a;
        return b;
    }

    void RollBack()
    {
        lld i,j;

        for (i=0;i<702;i++)
        {
            for (j=0;j<12;j++)
            {
                RMQ[i][j]=INF;
            }
        }

        n=0;
        memset(nums,-1,sizeof(nums));
    }

    void SetBasicValues()
    {
        lld i,j,cur;

        powah[0]=1;
        for (i=1;i<=11;i++)
        {
            powah[i]=powah[i-1]*2;
        }

        cur=1;
        chooselen[0]=0;
        for (i=1;i<=n;i++)
        {
            chooselen[i]=chooselen[i-1];

            if (cur*2 < i)
            {
                cur*=2;
                chooselen[i]++;
            }
        }
    }

    void InitializeRMQ()
    {
        lld i,j;

        for (i=1;i<=n;i++)
        {
            RMQ[i][0]=nums[i];
        }

        for (j=1;j<=chooselen[n];j++)
        {
            for (i=1;i<=n-powah[chooselen[j]];i++)
            {
                RMQ[i][j]= MN(RMQ[i][j-1], RMQ[i+powah[j-1]][j-1]);
            }
        }
    }

    void GetReady(lld temp[],lld len)
    {
        lld i,j;

        RollBack();

        n=len;
        for (i=1;i<=n;i++)
        {
            nums[i]=temp[i];
        }

        SetBasicValues();
        InitializeRMQ();
    }

    void Swap(lld *a, lld *b)
    {
        lld rz = *a;
        *a = *b;
        *b = rz;
    }

    lld GetAnswer(lld l,lld r)
    {
        if (r < l) Swap(&l, &r);

        lld len,st;

        len=r-l+1;
        st=chooselen[len];

        return MN(RMQ[l][st], RMQ[r-powah[st]+1][st]);
    }
};

UFStructure kruskal;

lld n, m;
vector<GRPH> Graph[302];
vector<VRTX> vertex, invertex;
vector<lld> answer, cur;
lld times[302][302];



lld path[302];
vector<GRPH> gtans[302];
lld UTFO[302], TFOkey = 0;
lld tarvert = 0;

lld mindist[302][302];
lld lastupdate[302][302];
lld vertdist[302][302];
VRTX getvert[302][302];
lld vertnum[302][302];
vector<Cool> apsort;
vector<lld> lhelp;


lld curans = INF;

lld MN(lld a, lld b)
{
    if (a < b) return a;
    return b;
}

lld eabs(lld num)
{
    if (num<0) return -num;
    return num;
}

void DFS_tarvert(lld vert)
{
    UTFO[vert] = TFOkey;
    bool success=false;

    for (lld i=0;i<gtans[vert].size();i++)
    {
        if (UTFO[gtans[vert][i].vert] == TFOkey) continue;

        success= true;
        DFS_tarvert(gtans[vert][i].vert);
    }

    if (!success)
    {
        tarvert = vert;
        return ;
    }
}

void DFS_fill(lld vert, lld dist)
{
    Cool helper;
    lld dst;

    UTFO[vert] = TFOkey;

    dst = dist;

    path[vert] = dist;

    for (lld i=0;i<gtans[vert].size();i++)
    {
        if (UTFO[gtans[vert][i].vert] == TFOkey) continue;

        DFS_fill(gtans[vert][i].vert, dist + gtans[vert][i].val);
    }
}

void Swap(lld *a,lld *b)
{
    lld rz=*a;
    *a=*b;
    *b=rz;
}

RangeMinimumQuery work;

lld first[302];
lld number[302],org[302],cnt;

lld arr[702],len=0;

void DFS(lld vert)
{
    UTFO[vert]=TFOkey;

    number[vert]=++cnt;
    org[cnt]=vert;
    arr[++len]=number[vert];

    first[vert]=len;
    for (lld i=0;i<gtans[vert].size();i++)
    {
        if (UTFO[gtans[vert][i].vert]==TFOkey) continue;

        DFS(gtans[vert][i].vert);

        arr[++len]=number[vert];
    }
}

lld GetAnswer(vector<lld> vernum)
{
    lld i,j,ii,jj,ind,t;
    lld tests,vert;
    lld ind1,ind2,vert1,vert2;
    lld lc, dst;

    GRPH hpr1;
    lld ret = 0, dist;

    for (i=0;i<302;i++)
    {
        path[i] = 0;
        gtans[i].clear();
    }

    for (i=0;i<vernum.size();i++)
    {
        vert1 = invertex[vernum[i] - 1].vert1;
        vert2 = invertex[vernum[i] - 1].vert2;
        dist = invertex[vernum[i] - 1].val;

        hpr1.SetValues(vert2, dist);
        gtans[vert1].push_back(hpr1);

        hpr1.SetValues(vert1, dist);
        gtans[vert2].push_back(hpr1);
    }

    TFOkey++;
    DFS_tarvert(vert1);

    path[tarvert] = 0;

    TFOkey++;
    DFS_fill(tarvert, 0);

    TFOkey++;

    len=0;
    cnt=0;

    DFS(tarvert);
    work.GetReady(arr,len);

    for (vert1 = 1;vert1 < n;vert1++)
    {
        for (vert2 = vert1 + 1;vert2 <= n;vert2++)
        {
            ind1=first[vert1];
            ind2=first[vert2];

            if (ind1>ind2) Swap(&ind1,&ind2);

            lc = work.GetAnswer(ind1,ind2);
            lc = org[lc];

            if (lc == vert1 || lc == vert2)
            {
                dst = eabs(path[vert1] - path[vert2]);
            }
            else
            {
                dst = path[vert1] + path[vert2] - path[lc]*2;
            }

            ret += dst * times[vert1][vert2];
        }
    }

    return ret;
}


vector<lld> GetPath(lld vert1, lld vert2)
{
    vector<lld> ret, svr;
    if (lastupdate[vert1][vert2] == 0)
    {
        ret.push_back(vertnum[vert1][vert2]);
        return ret;
    }

    ret = GetPath(vert1, lastupdate[vert1][vert2]);

    svr= GetPath(lastupdate[vert1][vert2], vert2);
    for (lld i=0;i<svr.size();i++)
    {
        ret.push_back(svr[i]);
    }

    return ret;
}

bool CoolSorter_ToLow(Cool a, Cool b)
{
    return (a.dist > b.dist);
}
bool TFO[50002];

bool Sort_By_Weight(VRTX a, VRTX b)
{
    return (a.val < b.val);
}

vector<Cool> pts;

lld FirstNotTrued()
{
    lld ret = INF;
    lld l,r,mid;

    l = 0;
    r = lhelp.size() - 1;

    while (l<=r)
    {
        mid = (l+r)/2;

        if (TFO[lhelp[mid]])
        {
            l=mid+1;
        }
        else
        {
            ret = mid;
            r = mid -1;
        }
    }

    return ret;
}



int main ()
{
    memset(UTFO, 0, sizeof(UTFO));
    freopen("graph.in","r",stdin);
    freopen("graph.out","w",stdout);

    lld i,j,ii,jj,ind;
    lld h1,h2,h3;
    GRPH hpr1;
    VRTX vrhelp;
    lld bigh;

    double timepassed;
    const double cps = CLOCKS_PER_SEC / 1000;

    for (i=0;i<302;i++)
    {
        for (j=0;j<302;j++)
        {
            mindist[i][j] = INF;
            lastupdate[i][j] = 0;
            vertdist[i][j] = -INF;
        }
    }

    scanf("%lld %lld",&n,&m);
    for (i=1;i<=m;i++)
    {
        scanf("%lld",&h1);
        scanf("%lld",&h2);
        scanf("%lld",&h3);
        //cin>>h1>>h2>>h3;

        hpr1.SetValues(h2,h3);
        Graph[h1].push_back(hpr1);

        hpr1.SetValues(h1,h3);
        Graph[h2].push_back(hpr1);

        vrhelp.SetValues(h1, h2, h3, i);
        vertex.push_back(vrhelp);
        invertex.push_back(vrhelp);

        getvert[h1][h2] = vrhelp;
        getvert[h2][h1] = vrhelp;
        vertnum[h1][h2] = i;
        vertnum[h2][h1] = i;
        mindist[h1][h2] = h3;
        mindist[h2][h1] = h3;
        vertdist[h1][h2] = 1;
        vertdist[h2][h1] = 1;
    }
    for (i=1;i<=n;i++)
    {
        Cool helper;
        helper.vert = i;
        helper.dist = 0;
        pts.push_back(helper);

        for (j=1;j<=n;j++)
        {
            scanf("%lld",&times[i][j]);
        }
    }

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=n;j++)
        {
            pts[i-1].dist += times[i][j];
        }
    }
    sort(pts.begin(), pts.end(), CoolSorter_ToLow);

     sort(vertex.begin(), vertex.end(), Sort_By_Weight);

    kruskal.Initialize();
    kruskal.SetAllVerts(vertex);
    cur = kruskal.GetAnswer();
    bigh = GetAnswer(cur);

    if (curans > bigh)
    {
        answer = cur;
    }
    //cout<<bigh<<endl;

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=n;j++)
        {
            if (i==j) continue;

            for (ind=1;ind<=n;ind++)
            {
                if (j==ind || i==ind) continue;
                if (mindist[i][j] == INF || mindist[i][ind] == INF) continue;

                if (mindist[j][ind] > mindist[i][j] + mindist[i][ind])
                {
                    lastupdate[j][ind] =i;
                    lastupdate[ind][j] =i;

                    vertdist[ind][j] = vertdist[i][j] + vertdist[i][ind];
                    vertdist[j][ind] = vertdist[i][j] + vertdist[i][ind];

                    mindist[ind][j] = mindist[i][j] + mindist[i][ind];
                    mindist[j][ind] = mindist[i][j] + mindist[i][ind];
                }
            }
        }
    }
    lld p;

    for (lld ii=0;ii<n;ii++)
    {
        p = pts[ii].vert;
        cur.clear();
        apsort.clear();

        for (i=1;i<=n;i++)
        {
            Cool helper;

            helper.dist = vertdist[p][i];
            helper.vert = i;
            apsort.push_back(helper);
        }

        sort(apsort.begin(), apsort.end(), CoolSorter_ToLow);

        memset(TFO, 0, sizeof(TFO));
        TFOkey++;
        for (i=0;i<apsort.size();i++)
        {
            if (UTFO[apsort[i].vert] == TFOkey) continue;

            lhelp = GetPath(p, apsort[i].vert);
            lld lim = FirstNotTrued();

            for (j=lim;j<lhelp.size();j++)
            {
                UTFO[invertex[lhelp[j]-1].vert1] = TFOkey;
                UTFO[invertex[lhelp[j]-1].vert2] = TFOkey;

                //if (!TFO[lhelp[j]])
                    cur.push_back(lhelp[j]);

                TFO[lhelp[j]] = true;
            }
        }

        timepassed = clock()/cps;
        if (timepassed > 1600) break;

        bigh = GetAnswer(cur);

        if (bigh < curans)
        {
            curans = bigh;
            answer = cur;
        }
    }
    TFOkey++;

    for (i=0;i<answer.size();i++)
    {
        cout<<answer[i]<<endl;
    }
}

